// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockPluginVersions is an autogenerated mock type for the PluginVersions type
type MockPluginVersions struct {
	mock.Mock
}

// CreatePluginVersion provides a mock function with given fields: ctx, pluginVersion
func (_m *MockPluginVersions) CreatePluginVersion(ctx context.Context, pluginVersion *models.PluginVersion) (*models.PluginVersion, error) {
	ret := _m.Called(ctx, pluginVersion)

	if len(ret) == 0 {
		panic("no return value specified for CreatePluginVersion")
	}

	var r0 *models.PluginVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginVersion) (*models.PluginVersion, error)); ok {
		return rf(ctx, pluginVersion)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginVersion) *models.PluginVersion); ok {
		r0 = rf(ctx, pluginVersion)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PluginVersion) error); ok {
		r1 = rf(ctx, pluginVersion)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePluginVersion provides a mock function with given fields: ctx, pluginVersion
func (_m *MockPluginVersions) DeletePluginVersion(ctx context.Context, pluginVersion *models.PluginVersion) error {
	ret := _m.Called(ctx, pluginVersion)

	if len(ret) == 0 {
		panic("no return value specified for DeletePluginVersion")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginVersion) error); ok {
		r0 = rf(ctx, pluginVersion)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetPluginVersionByID provides a mock function with given fields: ctx, id
func (_m *MockPluginVersions) GetPluginVersionByID(ctx context.Context, id string) (*models.PluginVersion, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginVersionByID")
	}

	var r0 *models.PluginVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PluginVersion, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PluginVersion); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPluginVersionByPRN provides a mock function with given fields: ctx, prn
func (_m *MockPluginVersions) GetPluginVersionByPRN(ctx context.Context, prn string) (*models.PluginVersion, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginVersionByPRN")
	}

	var r0 *models.PluginVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PluginVersion, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PluginVersion); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPluginVersions provides a mock function with given fields: ctx, input
func (_m *MockPluginVersions) GetPluginVersions(ctx context.Context, input *GetPluginVersionsInput) (*PluginVersionsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginVersions")
	}

	var r0 *PluginVersionsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPluginVersionsInput) (*PluginVersionsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPluginVersionsInput) *PluginVersionsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PluginVersionsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPluginVersionsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdatePluginVersion provides a mock function with given fields: ctx, pluginVersion
func (_m *MockPluginVersions) UpdatePluginVersion(ctx context.Context, pluginVersion *models.PluginVersion) (*models.PluginVersion, error) {
	ret := _m.Called(ctx, pluginVersion)

	if len(ret) == 0 {
		panic("no return value specified for UpdatePluginVersion")
	}

	var r0 *models.PluginVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginVersion) (*models.PluginVersion, error)); ok {
		return rf(ctx, pluginVersion)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginVersion) *models.PluginVersion); ok {
		r0 = rf(ctx, pluginVersion)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PluginVersion) error); ok {
		r1 = rf(ctx, pluginVersion)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockPluginVersions creates a new instance of MockPluginVersions. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPluginVersions(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPluginVersions {
	mock := &MockPluginVersions{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
